#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Data::Filter::Rule::List class and it`s subclassess tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
# Comments:
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 13;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Data::Filter::Rule::List';

        use_ok('Tester');
        use_ok('Data::Filter::Rule');
        use_ok('Data::Filter::Rule::Atom');
        use_ok('Data::Filter::Rule::Constant');
        use_ok('Data::Core');
        use_ok($TESTED_CLASS);
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
diag("$TESTED_CLASS version: " . $Data::Filter::Rule::List::VERSION) if Tester::D();

# Now attempt to create a class instance and check it
my $instance = $TESTED_CLASS->new('list', 'value1,value2');
isa_ok($instance, $TESTED_CLASS);

# Test the rule interface
is_deeply($instance->value(),     ['value1','value2'],   "Rule interface test 01");
is_deeply($instance->value_raw(), ['value1','value2'],   "Rule interface test 02");
is($instance->datatype(),         'UNKNOWN',             "Rule interface test 03");
is($instance->operation(),        undef,                 "Rule interface test 04");
is($instance->name(),             'List',                "Rule interface test 05");
is($instance->to_string(),        '["value1","value2"]', "Rule interface test 06");

# View the created instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D();
